"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TemplateExtractor = void 0;
const fs = __importStar(require("fs"));
const _config_1 = require("./_config");
const path_1 = __importDefault(require("path"));
const ErrorList_1 = require("./ErrorList");
class TemplateExtractor {
    constructor(templateReader, replaceVal, subdomain) {
        this.templateReader = templateReader;
        this.replaceVal = replaceVal;
        this.subdomain = subdomain;
    }
    getComponentDirName() {
        const genericDirName = this.templateReader.templateDirName;
        return genericDirName.replace(_config_1.genericKeyword, this.replaceVal);
    }
    getComponentFiles() {
        return __awaiter(this, void 0, void 0, function* () {
            const filesResult = yield this.templateReader.getTemplateFiles();
            if (filesResult instanceof Error)
                return filesResult;
            return filesResult.map(templateFileInfo => ({
                fileName: templateFileInfo.fileName.replace(_config_1.genericKeyword, this.replaceVal),
                data: ""
            }));
        });
    }
    getComponentWrkDirPath(componentWrkDir) {
        let compWrkDirPath;
        if (typeof componentWrkDir === "string") {
            compWrkDirPath = path_1.default.resolve(componentWrkDir);
            if (!fs.existsSync(compWrkDirPath))
                return new Error(ErrorList_1.ErrorList.COMPONENT_WRK_DIR_NOT_EXISTE(compWrkDirPath));
            return compWrkDirPath;
        }
        const { rootWorkDir, extensionWorkDir } = componentWrkDir;
        const rootWrkDirPath = path_1.default.resolve(rootWorkDir);
        if (!fs.existsSync(rootWrkDirPath))
            return new Error(ErrorList_1.ErrorList.ROOT_WRK_DIR_NOT_EXISTE(rootWorkDir));
        let subdomainPath;
        if (this.subdomain) {
            subdomainPath = `${rootWrkDirPath}/${this.subdomain}`;
            if (!fs.existsSync(subdomainPath))
                return new Error(ErrorList_1.ErrorList.SUBDOMAIN_PATH_NOT_EXISTE(this.subdomain, path_1.default.relative(path_1.default.resolve(), rootWrkDirPath)));
            compWrkDirPath = `${subdomainPath}/${this.subdomain}/${extensionWorkDir}`;
            if (!fs.existsSync(compWrkDirPath))
                return new Error(ErrorList_1.ErrorList.EXTENTION_WRK_DIR_NOT_EXISTE(extensionWorkDir, path_1.default.relative(path_1.default.resolve(), subdomainPath)));
            return compWrkDirPath;
        }
        compWrkDirPath = `${rootWrkDirPath}/${extensionWorkDir}`;
        if (!fs.existsSync(compWrkDirPath))
            return new Error(ErrorList_1.ErrorList.EXTENTION_WRK_DIR_NOT_EXISTE(extensionWorkDir, path_1.default.relative(path_1.default.resolve(), subdomainPath)));
        return compWrkDirPath;
    }
}
exports.TemplateExtractor = TemplateExtractor;
//# sourceMappingURL=TemplateExtractor.js.map