#! /usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = require("commander");
const Create_1 = require("./commands/Create");
const CommandEnum_1 = require("./_definitions/CommandEnum");
const Initialize_1 = require("./commands/Initialize");
const run = () => __awaiter(void 0, void 0, void 0, function* () {
    const program = new commander_1.Command();
    program.version('2.0.0');
    program
        .command(CommandEnum_1.CommandEnum.init)
        .description(`If config directory does not exist : Create configs files and 1 example modele. Else, check templates validity and cache your current configurations`)
        .action(() => { Initialize_1.initializer.reload(true); });
    program
        .command(CommandEnum_1.CommandEnum.create)
        .argument('<templateName>', "Template to use")
        .argument('<replacementName>', "Replacement word")
        .option('-s, --subdomain <subdomain>', 'Allows to choose a subdomain in which the component will be created')
        .description(`Create component`)
        .action(Create_1.create);
    if (process.argv.length > 2)
        yield program.parseAsync(process.argv);
    else
        console.log("Bienvenue sur component-creator-CLI");
});
run().then();
//# sourceMappingURL=app.js.map